install-sgx-psw.bin.tmpl 3.6 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123
  1. #!/usr/bin/env bash
  2. #
  3. # Copyright (C) 2011-2017 Intel Corporation. All rights reserved.
  4. #
  5. # Redistribution and use in source and binary forms, with or without
  6. # modification, are permitted provided that the following conditions
  7. # are met:
  8. #
  9. # * Redistributions of source code must retain the above copyright
  10. # notice, this list of conditions and the following disclaimer.
  11. # * Redistributions in binary form must reproduce the above copyright
  12. # notice, this list of conditions and the following disclaimer in
  13. # the documentation and/or other materials provided with the
  14. # distribution.
  15. # * Neither the name of Intel Corporation nor the names of its
  16. # contributors may be used to endorse or promote products derived
  17. # from this software without specific prior written permission.
  18. #
  19. # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  20. # "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  21. # LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  22. # A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  23. # OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  24. # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  25. # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  26. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  27. # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  28. # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  29. # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  30. #
  31. #
  32. modinfo isgx &> /dev/null
  33. if [[ $? != "0" ]]; then
  34. lsmod | grep isgx &> /dev/null
  35. if [[ $? = "0" ]]; then
  36. echo "Warning: You did not follow the document to install the driver package"
  37. echo
  38. else
  39. echo "Please install the driver package before the PSW package"
  40. exit 4
  41. fi
  42. fi
  43. set -e
  44. PKG_NAME="Intel SGX PSW Package"
  45. if test $(id -u) -ne 0; then
  46. echo "Root privilege is required to install $PKG_NAME."
  47. exit 4
  48. fi
  49. PKG_ARCH=@arch@
  50. ARCH=$(uname -m)
  51. if [ $ARCH == "i386" ] || [ $ARCH == "i586" ] || [ $ARCH == "i686" ]; then
  52. ARCH=x86
  53. fi
  54. if [[ $ARCH != $PKG_ARCH ]]; then
  55. echo "$PKG_ARCH $PKG_NAME can not be installed on $ARCH platform."
  56. exit 4
  57. fi
  58. INSTALL_PATH=/opt/intel/sgxpsw
  59. if [ -d "$INSTALL_PATH" ]; then
  60. echo "$PKG_NAME already exists in $INSTALL_PATH, please uninstall it first!"
  61. exit 4
  62. fi
  63. PATH=/usr/bin:/bin
  64. umask 022
  65. PSWPKG=`mktemp -t sgx-psw-pkg.XXXXXX`
  66. PSW_TEMP_FOLDER=`mktemp -d sgx-psw-XXXXXX -p /tmp`
  67. trap "rm -fr $PSWPKG $PSW_TEMP_FOLDER= 2>/dev/null; exit 3" HUP INT QUIT TERM
  68. # The number of lines in this script (plus 1). Using this number to
  69. # calculate the start address of the payload.
  70. NR_SCRIPT_LINES=@linenum@
  71. # Run /usr/bin/md5sum on the binary payload to get the MD5 check sum.
  72. CHKSUM=@md5sum@
  73. # Get the install payload from this shell script.
  74. echo -n "Unpacking $PKG_NAME ..."
  75. tail -n +$NR_SCRIPT_LINES "$0" > $PSWPKG
  76. echo " done."
  77. echo -n "Verifying the integrity of the install package ..."
  78. if test $(md5sum $PSWPKG | awk '{print $1}') != $CHKSUM; then
  79. echo " The install package appears to be corrupted."
  80. exit 1
  81. fi
  82. echo " done."
  83. echo -n "Installing $PKG_NAME ..."
  84. tar zxf $PSWPKG -C $PSW_TEMP_FOLDER >/dev/null 2>&1
  85. retcode=$? # Save the return code
  86. # Clean-up the temporary tarball.
  87. rm -f $PSWPKG 2>/dev/null
  88. if test $retcode -ne 0; then
  89. echo " failed."
  90. exit 2
  91. fi
  92. echo " done."
  93. pushd $PSW_TEMP_FOLDER
  94. source scripts/installConfig
  95. make install
  96. popd
  97. ${SGX_PACKAGES_PATH}/${PSW_PKG_NAME}/scripts/install.sh
  98. rm -fr ${PSW_TEMP_FOLDER}
  99. exit 0